<template>
  <AppPage>
    <h1>Course Linking</h1>
    <p>Link courses to push enrollments from one or more classes to another</p>
    <CourseSelectorMaineStreet @change="course_selected"/>
    <div v-show="selected_course_is_child" class="font-weight-bold text-danger">
      The course you have selected is already listed as a child in another
      course. Please select a different course.
    </div>
    <div v-show="!selected_course_is_child && selected_course_code.length > 0">
      <b-overlay :show="linked_courses_fetching" rounded="sm">
        <b-card
            title="Linked Courses"
            tag="article"
            style="max-width: 60rem; min-width: 400px;"
            class="mb-2"
            :aria-hidden="linked_courses_fetching ? 'true' : null"
        >
          <div class="card-header">
            <b-button
                block
                pill
                size="sm"
                v-b-modal.modalAddLinkedCourse
                v-if="hasPermission('post:linkedCourse')"
            >Add
            </b-button>
          </div>
          <div
              class="card-body"
              id="divLinkedCourses"
              v-if="hasPermission('get:linkedCourse-children')"
          >
            <b-table
                id="tblLinkedCourses"
                :items="filtered"
                :fields="fields"
                striped
                small
            >
              <template slot="top-row" slot-scope="{ fields }">
                <td
                    :class="field.class"
                    v-for="field in fields"
                    :key="field.key"
                >
                  <label
                      :for="'sort-' + field.key"
                      v-if="field.sortable"
                      class="sr-only"
                  >{{ field.label }}</label
                  >
                  <input
                      :id="'sort-' + field.key"
                      v-model="filters[field.key]"
                      :placeholder="field.label"
                      size="10"
                      v-if="field.sortable"
                  />
                </td>
              </template>
              <template v-slot:cell(actions)="row">
                <b-button
                    size="sm"
                    @click="deleteLinkedCourse(row.item)"
                    class="mr-1"
                    pill
                    :id="'btnDeleteLinkedCourse_' + row.item.code"
                    v-if="hasPermission('delete:linkedCourse')"
                >
                  Delete
                </b-button>
                <AdminHelpTooltip
                    :target="'btnDeleteLinkedCourse_' + row.item.code"
                    permissions="delete:linkedCourse"
                />
              </template>
            </b-table>
          </div>
          <AdminHelpTooltip
              target="divLinkedCourses"
              permissions="get:linkedCourse-children"
          />
        </b-card>
      </b-overlay>
    </div>
    <b-modal
        id="modalAddLinkedCourse"
        title="Add Linked Course"
        @ok="addLinkedCourseOk"
        @cancel="addLinkedCourseCancel"
    >
      <b-form @submit.stop.prevent="addLinkedCourse">
        <course-selector-maine-street
            @change="linked_course_selected"
            v-bind:populate_globally_selected_code="false"
        ></course-selector-maine-street>
      </b-form>
      <div v-show="addLinkedCourseHasErrors">
        {{ addLinkedCourseError }}
      </div>
    </b-modal>
  </AppPage>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  data () {
    return {
      filters: {
        title: '',
        code: '',
        instructorNames: ''
      },
      fields: [
        { key: 'title', label: 'Title', sortable: true, filterable: true },
        { key: 'code', label: 'Code', sortable: true, filterable: true },
        {
          key: 'instructorNames',
          label: 'Instructors',
          sortable: true,
          filterable: true
        },
        { key: 'actions', label: 'Actions', sortable: false, filterable: false }
      ],
      selected_linked_course: ''
    };
  },
  computed: {
    ...mapGetters({
      linked_courses_fetching: 'Courses/Linking/linked_courses_fetching',
      selected_course_code: 'selected_course_code',
      linked_courses_status_code: 'Courses/Linking/linked_courses_status_code',
      hasPermission: 'Navbar/hasPermission',
      items: 'Courses/Linking/linked_courses'
    }),
    selected_course_is_child () {
      return this.linked_courses_status_code === 409;
    },
    fetching () {
      return this.linked_courses_fetching;
    },
    filtered () {
      if (Array.isArray(this.items)) {
        return this.items.filter(item => {
          return Object.keys(this.filters).every(key =>
              String(item[key].toLowerCase()).includes(
                  this.filters[key].toLowerCase()
              )
          );
        });
      } else {
        return [];
      }
    },
    addLinkedCourseHasErrors () {
      let errs = 0;
      if (this.selected_linked_course.length <= 0) {
        errs += 1;
      }
      if (this.selected_course_code === this.selected_linked_course) {
        errs += 1;
      }

      return errs > 0;
    },
    addLinkedCourseError () {
      if (this.selected_course_code === this.selected_linked_course) {
        return 'Cannot add ' + this.selected_course_code + ' to its self.';
      }

      return '';
    }
  },
  methods: {
    ...mapActions({
      get_linked_courses: 'Courses/Linking/get_linked_courses',
      delete_linked_course: 'Courses/Linking/delete_linked_course',
      add_linked_course: 'Courses/Linking/add_linked_course'
    }),
    course_selected (code) {
      if (code.length > 0 && this.hasPermission('get:linkedCourse-children')) {
        this.get_linked_courses(code);
      }
    },
    linked_course_selected (code) {
      if (code.length > 0) {
        this.selected_linked_course = code;
      }
    },
    deleteLinkedCourse (item) {
      if (this.hasPermission('delete:linkedCourse')) {
        this.$bvModal
            .msgBoxConfirm(
                'Removing ' +
                item.code +
                ' will not automatically remove the enrollments for this course. Visit Course > Enrollments to fix the enrollments.'
            )
            .then(value => {
              if (value) {
                this.delete_linked_course({
                  parentCode: item.parentCode,
                  code: item.code
                });
              }
            });
      }
    },
    addLinkedCourseOk (modalEvent) {
      if (this.addLinkedCourseHasErrors) {
        modalEvent.preventDefault();
      }
      this.addLinkedCourse();
    },
    addLinkedCourse () {
      if (
          this.addLinkedCourseHasErrors ||
          !this.hasPermission('post:linkedCourse')
      ) {
        return;
      }

      if (this.selected_linked_course.length > 0) {
        if (
            this.items.findIndex(
                lc => lc.code === this.selected_linked_course
            ) === -1
        ) {
          this.add_linked_course({
            parentCode: this.selected_course_code,
            code: this.selected_linked_course
          });
        } else {
          this.$store.dispatch('add_alert', {
            variant: 'warning',
            msg: this.selected_linked_course + ' already exists '
          });
        }
      }
    },
    addLinkedCourseCancel () {}
  },
  mounted () {
    this.course_selected(this.selected_course_code);
  }
};
</script>
